local _, C = unpack(select(2, ...))

C.RaidDebuffsBlackList = {
    [23445] = true, -- 邪恶双子
    [36893] = true, -- 传送器故障
    [36895] = true, -- 传送器故障
    [36897] = true, -- 传送器故障
    [36899] = true, -- 传送器故障
    [36900] = true, -- 灵魂分裂：坏蛋
    [36901] = true, -- 灵魂分裂：好人
    [36940] = true, -- 传送器故障
    [206151] = true, --挑战者的负担
    [296847] = true, -- 压迫光环
    [338906] = true, -- 典狱长之链
}

C.RaidBuffsWhiteList = {
    [642] = true, -- 圣盾术
    [871] = true, -- 盾墙
    [1022] = true, -- 保护祝福
    [1044] = true, -- 自由祝福
    [6940] = true, -- 牺牲祝福
    [10060] = true, -- 能量灌注
    [22812] = true, -- 树皮术
    [61336] = true, -- 生存本能
    [27827] = true, -- 救赎之魂
    [31224] = true, -- 暗影斗篷
    [33206] = true, -- 痛苦压制
    [45438] = true, -- 冰箱
    [47585] = true, -- 消散
    [47788] = true, -- 守护之魂
    [48792] = true, -- 冰封之韧
    [86659] = true, -- 远古列王守卫
    [102342] = true, -- 铁木树皮
    [102558] = true, -- 熊化身
    [104773] = true, -- 不灭决心
    [108271] = true, -- 星界转移
    [110909] = true, -- 操控时间
    [115203] = true, -- 壮胆酒
    [116849] = true, -- 作茧缚命
    [118038] = true, -- 剑在人在
    [160029] = true, -- 正在复活
    [186265] = true, -- 灵龟守护
    [196555] = true, -- 虚空行走
    [204018] = true, -- 破咒祝福
    [204150] = true, -- 圣光护盾
    [264735] = true, -- 优胜劣汰
    [281195] = true, -- 优胜劣汰
    [374348] = true, -- 新生光焰
    [363916] = true, -- 黑曜鳞片
}

-- Corner spells
-- [spellID] = {anchor, {r, g, b}, ALL}
C.CornerSpellsList = {
    ['PRIEST'] = {
        [194384] = { 'TOPRIGHT', { 1, 1, 0.66 } }, -- 救赎
        [214206] = { 'TOPRIGHT', { 1, 1, 0.66 } }, -- 救赎(PvP)
        [41635] = { 'BOTTOMRIGHT', { 0.2, 0.7, 0.2 } }, -- 愈合导言
        [193065] = { 'BOTTOMRIGHT', { 0.54, 0.21, 0.78 } }, -- 忍辱负重
        [139] = { 'TOPLEFT', { 0.4, 0.7, 0.2 } }, -- 恢复
        [17] = { 'TOPLEFT', { 0.7, 0.7, 0.7 } }, -- 真言术盾
        [47788] = { 'LEFT', { 0.86, 0.45, 0 }, true }, -- 守护之魂
        [33206] = { 'LEFT', { 0.47, 0.35, 0.74 }, true }, -- 痛苦压制
        [6788] = { 'TOP', { 0.86, 0.11, 0.11 }, true }, -- 虚弱灵魂
    },
    ['DRUID'] = {
        [774] = { 'TOPRIGHT', { 0.8, 0.4, 0.8 } }, -- 回春
        [155777] = { 'RIGHT', { 0.6, 0.4, 0.8 } }, -- 萌芽
        [8936] = { 'LEFT', { 0.2, 0.8, 0.2 } }, -- 愈合
        [33763] = { 'TOPLEFT', { 0.4, 0.8, 0.2 } }, -- 生命绽放
        [188550] = { 'TOPLEFT', { 0.4, 0.8, 0.2 } }, -- 生命绽放，橙装
        [48438] = { 'BOTTOMRIGHT', { 0.8, 0.4, 0 } }, -- 野性成长
        [29166] = { 'TOP', { 0, 0.4, 1 } }, -- 激活
        [391891] = { 'TOP', { 0, 0.8, 0.4 } }, -- 激变蜂群
        [102351] = { 'BOTTOM', { 0.2, 0.8, 0.8 } }, -- 结界
        [102352] = { 'BOTTOM', { 0.2, 0.8, 0.8 } }, -- 结界(HoT)
        [200389] = { 'BOTTOM', { 1, 1, 0.4 } }, -- 栽培
    },
    ['EVOKER'] = {
        [355941] = { 'TOPLEFT', { 0.4, 0.7, 0.2 } }, -- 梦境吐息
        [364343] = { 'TOPRIGHT', { 0, 0.8, 0.8 } }, -- 回响
        [366155] = { 'RIGHT', { 1, 0.9, 0.5 } }, -- 逆转
        [370888] = { 'TOP', { 0, 0.4, 1 } }, -- 双生护卫
        [357170] = { 'LEFT', { 0.47, 0.35, 0.74 }, true }, -- 时间膨胀
    },
    ['PALADIN'] = {
        [287280] = { 'TOPLEFT', { 1, 0.8, 0 } }, -- 圣光闪烁
        [53563] = { 'TOPRIGHT', { 0.7, 0.3, 0.7 } }, -- 道标
        [156910] = { 'TOPRIGHT', { 0.7, 0.3, 0.7 } }, -- 信仰道标
        [200025] = { 'TOPRIGHT', { 0.7, 0.3, 0.7 } }, -- 美德道标
        [1022] = { 'BOTTOMRIGHT', { 0.2, 0.2, 1 }, true }, -- 保护
        [1044] = { 'BOTTOMRIGHT', { 0.89, 0.45, 0 }, true },
        -- 自由
        [6940] = { 'BOTTOMRIGHT', { 0.89, 0.1, 0.1 }, true },
        -- 牺牲
        [223306] = { 'BOTTOM', { 0.7, 0.7, 0.3 } }, -- 赋予信仰
        [25771] = { 'TOP', { 0.86, 0.11, 0.11 }, true }, -- 自律
    },
    ['SHAMAN'] = {
        [61295] = { 'TOPRIGHT', { 0.2, 0.8, 0.8 } }, -- 激流
        [974] = { 'BOTTOMRIGHT', { 1, 0.8, 0 } }, -- 大地之盾
    },
    ['MONK'] = {
        [119611] = { 'TOPLEFT', { 0.3, 0.8, 0.6 } }, -- 复苏之雾
        [116849] = { 'TOP', { 0.2, 0.8, 0.2 }, true }, -- 作茧缚命
        [124682] = { 'TOPRIGHT', { 0.8, 0.8, 0.25 } }, -- 氤氲之雾
        [191840] = { 'BOTTOMRIGHT', { 0.27, 0.62, 0.7 } }, -- 精华之泉
    },
    ['ROGUE'] = {
        [57934] = { 'BOTTOMRIGHT', { 0.9, 0.1, 0.1 } }, -- 嫁祸
    },
    ['WARRIOR'] = {
        [114030] = { 'TOPLEFT', { 0.2, 0.2, 1 } }, -- 警戒
    },
    ['HUNTER'] = {
        [34477] = { 'BOTTOMRIGHT', { 0.9, 0.1, 0.1 } }, -- 误导
        [90361] = { 'TOPLEFT', { 0.4, 0.8, 0.2 } }, -- 灵魂治愈
    },
    ['WARLOCK'] = {
        [20707] = { 'BOTTOMRIGHT', { 0.8, 0.4, 0.8 }, true }, -- 灵魂石
    },
    ['DEMONHUNTER'] = {},
    ['MAGE'] = {},
    ['DEATHKNIGHT'] = {},
}

C.BloodlustDebuffsList = {
    57723, -- 筋疲力尽
    57724, -- 心满意足
    80354, -- 时空错位
    264689, -- 疲倦
    390435, -- 筋疲力尽，龙希尔
}

-- Party watcher spells
-- [spellID] = duration in seconds
C.PartySpellsList = {
    [57994] = 12, -- 风剪
    [1766] = 15, -- 脚踢
    [6552] = 15, -- 拳击
    [47528] = 15, -- 心灵冰冻
    [96231] = 15, -- 责难
    [106839] = 15, -- 迎头痛击
    [116705] = 15, -- 切喉手
    [187707] = 15, -- 压制
    [119910] = 24, -- 法术封锁
    [147362] = 24, -- 反制射击
    [15487] = 45, -- 沉默
    [109248] = 45, -- 束缚射击
    [78675] = 60, -- 日光术
    [30283] = 45, -- 暗影之怒
    [8143] = 60, -- 战栗图腾
    [19577] = 60, -- 胁迫
    [102793] = 60, -- 乌索尔旋风
    [119381] = 60, -- 扫堂腿
    [205636] = 60, -- 树人
    [307865] = 60, -- 晋升堡垒之矛，格里恩
    [1719] = 90, -- 鲁莽
    [102342] = 90, -- 铁木树皮
    [325886] = 90, -- 上古余震，法夜
    [288613] = 120, -- 百发百中
    [31224] = 120, -- 暗影斗篷
    [31884] = 120, -- 复仇之怒
    [231895] = 120, -- 征罚
    [323764] = 120, -- 万灵之召
    [123904] = 120, -- 白虎下凡
    [192249] = 150, -- 风元素
    [198067] = 150, -- 火元素
    [13750] = 180, -- 冲动
    [186265] = 180, -- 灵龟守护
    [102560] = 180, -- 鸟德化身
    [194223] = 180, -- 超凡之盟
    [204018] = 180, -- 破咒祝福
    [316958] = 240, -- 红烬圣土，温西尔
    [1022] = 300, -- 保护祝福
    [25046] = 120, -- 奥术洪流
    [28730] = 120,
    [50613] = 120,
    [69179] = 120,
    [80483] = 120,
    [129597] = 120,
    [155145] = 120,
    [202719] = 120,
    [232633] = 120,
    -- mage
    [2139] = 24, -- 法术反制
    [190319] = 120, -- 燃烧
    [12042] = 120, -- 奥术强化
    [12472] = 180, -- 冰冷血脉
    [45438] = 240, -- 冰箱
    [113724] = 18, -- 冰霜之环
    -- dh
    [187827] = 180, -- 恶魔变形（复仇）
    [191427] = 240, -- 恶魔变形（浩劫）
    [183752] = 15, -- 瓦解
    [179057] = 60, -- 混乱新星
    [196555] = 180, -- 虚空行走
}

-- Talent modification
C.TalentCDFixList = {
    [740] = 120, -- 宁静
    [2094] = 90, -- 致盲
    [15286] = 75, -- 吸血鬼的拥抱
    [15487] = 30, -- 沉默
    [22812] = 40, -- 树皮术
    [30283] = 30, -- 暗影之怒
    [48792] = 165, -- 冰封之韧
    [79206] = 60, -- 灵魂行者的恩赐
    [102342] = 45, -- 铁木树皮
    [108199] = 90, -- 血魔之握
    [109304] = 105, -- 意气风发
    [116849] = 100, -- 作茧缚命
    [119381] = 40, -- 扫堂腿
    [179057] = 40, -- 混乱新星
}
